<?php
/*------------------------------------------------------------------------
# com_zhgooglemap - Zh GoogleMap
# ------------------------------------------------------------------------
# author    Dmitry Zhuk
# copyright Copyright (C) 2011 zhuk.cc. All Rights Reserved.
# @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPLv2 or later
# Websites: http://zhuk.cc
# Technical Support Forum: http://forum.zhuk.cc/
-------------------------------------------------------------------------*/
// No direct access to this file
defined('_JEXEC') or die('Restricted access');

/**
 * ZhGoogleMap component helper.
 */
abstract class ZhGoogleMapHelper
{
	/**
	 * Configure the Linkbar.
	 */
	public static function addSubmenu($submenu) 
	{
		JHtmlSidebar::addEntry(JText::_('COM_ZHGOOGLEMAP_SUBMENU_MAPS'), 'index.php?option=com_zhgooglemap&view=zhgooglemaps', $submenu == 'zhgooglemaps');
		JHtmlSidebar::addEntry(JText::_('COM_ZHGOOGLEMAP_SUBMENU_MAPMARKERS'), 'index.php?option=com_zhgooglemap&view=mapmarkers', $submenu == 'mapmarkers');
		JHtmlSidebar::addEntry(JText::_('COM_ZHGOOGLEMAP_SUBMENU_MAPMARKERGROUPS'), 'index.php?option=com_zhgooglemap&view=mapmarkergroups', $submenu == 'mapmarkergroups');
		JHtmlSidebar::addEntry(JText::_('COM_ZHGOOGLEMAP_SUBMENU_MAPROUTERS'), 'index.php?option=com_zhgooglemap&view=maprouters', $submenu == 'maprouters');
		JHtmlSidebar::addEntry(JText::_('COM_ZHGOOGLEMAP_SUBMENU_MAPPATHS'), 'index.php?option=com_zhgooglemap&view=mappaths', $submenu == 'mappaths');
		JHtmlSidebar::addEntry(JText::_('COM_ZHGOOGLEMAP_SUBMENU_MAPTYPES'), 'index.php?option=com_zhgooglemap&view=maptypes', $submenu == 'maptypes');
		JHtmlSidebar::addEntry(JText::_('COM_ZHGOOGLEMAP_SUBMENU_MAPINFOBUBBLES'), 'index.php?option=com_zhgooglemap&view=mapinfobubbles', $submenu == 'mapinfobubbles');
		JHtmlSidebar::addEntry(JText::_('COM_ZHGOOGLEMAP_SUBMENU_MAPSTREETVIEWS'), 'index.php?option=com_zhgooglemap&view=mapstreetviews', $submenu == 'mapstreetviews');
		//JHtmlSidebar::addEntry(JText::_('COM_ZHGOOGLEMAP_SUBMENU_MAPWIDGETTYPES'), 'index.php?option=com_zhgooglemap&view=mapwidgettypes', $submenu == 'mapwidgettypes');
		JHtmlSidebar::addEntry(JText::_('COM_ZHGOOGLEMAP_SUBMENU_MAPWEATHERTYPES'), 'index.php?option=com_zhgooglemap&view=mapweathertypes', $submenu == 'mapweathertypes');
		JHtmlSidebar::addEntry(JText::_('COM_ZHGOOGLEMAP_SUBMENU_MAPADSENCES'), 'index.php?option=com_zhgooglemap&view=mapadsences', $submenu == 'mapadsences');
		JHtmlSidebar::addEntry(JText::_('COM_ZHGOOGLEMAP_SUBMENU_CATEGORIES'), 'index.php?option=com_categories&view=categories&extension=com_zhgooglemap', $submenu == 'categories');
		JHtmlSidebar::addEntry(JText::_('COM_ZHGOOGLEMAP_SUBMENU_ABOUT'), 'index.php?option=com_zhgooglemap&view=abouts', $submenu == 'abouts');
		// set some global property
		$document = JFactory::getDocument();
		$document->addStyleDeclaration('.icon-48-zhgooglemap {background-image: url(../media/com_zhgooglemap/images/map-48x48.png);}');
		if ($submenu == 'categories') 
		{
			$document->setTitle(JText::_('COM_ZHGOOGLEMAP_ADMINISTRATION_CATEGORIES'));
		}
	}
	/**
	 * Get the actions
	 */
	public static function getMapActions($mapId = 0)
	{
		$user	= JFactory::getUser();
		$result	= new JObject;

		if (empty($mapId)) {
			$assetName = 'com_zhgooglemap';
		}
		else {
			$assetName = 'com_zhgooglemap';
			//$assetName = 'com_zhgooglemap.map.'.(int) $mapId;
		}

		$actions = array(
			'core.admin', 'core.manage', 'core.create', 'core.edit', 'core.edit.state', 'core.edit.own', 'core.delete'
		);

		foreach ($actions as $action) {
			$result->set($action,	$user->authorise($action, $assetName));
		}

		return $result;
	}

	public static function getMarkerActions($mapmarkerId = 0)
	{
		$user	= JFactory::getUser();
		$result	= new JObject;

		if (empty($mapmarkerId)) {
			$assetName = 'com_zhgooglemap';
		}
		else {
			$assetName = 'com_zhgooglemap';
			//$assetName = 'com_zhgooglemap.mapmarker.'.(int) $mapmarkerId;
		}

		$actions = array(
			'core.admin', 'core.manage', 'core.create', 'core.edit', 'core.edit.state', 'core.edit.own', 'core.delete'
		);

		foreach ($actions as $action) {
			$result->set($action,	$user->authorise($action, $assetName));
		}

		return $result;
	}

	public static function getMarkerGroupActions($mapmarkerGroupId = 0)
	{
		$user	= JFactory::getUser();
		$result	= new JObject;

		if (empty($mapmarkerGroupId)) {
			$assetName = 'com_zhgooglemap';
		}
		else {
			$assetName = 'com_zhgooglemap';
			//$assetName = 'com_zhgooglemap.mapmarkergroup.'.(int) $mapmarkerGroupId;
		}

		$actions = array(
			'core.admin', 'core.manage', 'core.create', 'core.edit', 'core.edit.state', 'core.edit.own', 'core.delete'
		);

		foreach ($actions as $action) {
			$result->set($action,	$user->authorise($action, $assetName));
		}

		return $result;
	}


	public static function getRouterActions($maprouterId = 0)
	{
		$user	= JFactory::getUser();
		$result	= new JObject;

		if (empty($maprouterId)) {
			$assetName = 'com_zhgooglemap';
		}
		else {
			$assetName = 'com_zhgooglemap';
			//$assetName = 'com_zhgooglemap.maprouter.'.(int) $maprouterId;
		}

		$actions = array(
			'core.admin', 'core.manage', 'core.create', 'core.edit', 'core.edit.state', 'core.edit.own', 'core.delete'
		);

		foreach ($actions as $action) {
			$result->set($action,	$user->authorise($action, $assetName));
		}

		return $result;
	}

	public static function getPathActions($mappathId = 0)
	{
		$user	= JFactory::getUser();
		$result	= new JObject;

		if (empty($mappathId)) {
			$assetName = 'com_zhgooglemap';
		}
		else {
			$assetName = 'com_zhgooglemap';
			//$assetName = 'com_zhgooglemap.mappath.'.(int) $mappathId;
		}

		$actions = array(
			'core.admin', 'core.manage', 'core.create', 'core.edit', 'core.edit.state', 'core.edit.own', 'core.delete'
		);

		foreach ($actions as $action) {
			$result->set($action,	$user->authorise($action, $assetName));
		}

		return $result;
	}

	public static function getTypeActions($maptypeId = 0)
	{
		$user	= JFactory::getUser();
		$result	= new JObject;

		if (empty($maptypeId)) {
			$assetName = 'com_zhgooglemap';
		}
		else {
			$assetName = 'com_zhgooglemap';
			//$assetName = 'com_zhgooglemap.maptype.'.(int) $maptypeId;
		}

		$actions = array(
			'core.admin', 'core.manage', 'core.create', 'core.edit', 'core.edit.state', 'core.edit.own', 'core.delete'
		);

		foreach ($actions as $action) {
			$result->set($action,	$user->authorise($action, $assetName));
		}

		return $result;
	}
	

	public static function getInfoBubbleActions($mapinfobubbleId = 0)
	{
		$user	= JFactory::getUser();
		$result	= new JObject;

		if (empty($mapinfobubbleId)) {
			$assetName = 'com_zhgooglemap';
		}
		else {
			$assetName = 'com_zhgooglemap';
			//$assetName = 'com_zhgooglemap.mapinfobubble.'.(int) $mapinfobubbleId;
		}

		$actions = array(
			'core.admin', 'core.manage', 'core.create', 'core.edit', 'core.edit.state', 'core.edit.own', 'core.delete'
		);

		foreach ($actions as $action) {
			$result->set($action,	$user->authorise($action, $assetName));
		}

		return $result;
	}
	

	
	public static function getStreetViewActions($mapstreetviewId = 0)
	{
		$user	= JFactory::getUser();
		$result	= new JObject;

		if (empty($mapstreetviewId)) {
			$assetName = 'com_zhgooglemap';
		}
		else {
			$assetName = 'com_zhgooglemap';
			//$assetName = 'com_zhgooglemap.mapstreetview.'.(int) $mapstreetviewId;
		}

		$actions = array(
			'core.admin', 'core.manage', 'core.create', 'core.edit', 'core.edit.state', 'core.edit.own', 'core.delete'
		);

		foreach ($actions as $action) {
			$result->set($action,	$user->authorise($action, $assetName));
		}

		return $result;
	}

	public static function getWeatherTypeActions($mapweathertypeId = 0)
	{
		$user	= JFactory::getUser();
		$result	= new JObject;

		if (empty($mapweathertypeId)) {
			$assetName = 'com_zhgooglemap';
		}
		else {
			$assetName = 'com_zhgooglemap';
			//$assetName = 'com_zhgooglemap.mapweathertype.'.(int) $mapweathertypeId;
		}

		$actions = array(
			'core.admin', 'core.manage', 'core.create', 'core.edit', 'core.edit.state', 'core.edit.own', 'core.delete'
		);

		foreach ($actions as $action) {
			$result->set($action,	$user->authorise($action, $assetName));
		}

		return $result;
	}

	public static function getWidgetTypeActions($mapwidgettypeId = 0)
	{
		$user	= JFactory::getUser();
		$result	= new JObject;

		if (empty($mapwidgettypeId)) {
			$assetName = 'com_zhgooglemap';
		}
		else {
			$assetName = 'com_zhgooglemap';
			//$assetName = 'com_zhgooglemap.mapwidgettype.'.(int) $mapwidgettypeId;
		}

		$actions = array(
			'core.admin', 'core.manage', 'core.create', 'core.edit', 'core.edit.state', 'core.edit.own', 'core.delete'
		);

		foreach ($actions as $action) {
			$result->set($action,	$user->authorise($action, $assetName));
		}

		return $result;
	}

	public static function getAdSenceActions($mapadsenceId = 0)
	{
		$user	= JFactory::getUser();
		$result	= new JObject;

		if (empty($mapadsenceId)) {
			$assetName = 'com_zhgooglemap';
		}
		else {
			$assetName = 'com_zhgooglemap';
			//$assetName = 'com_zhgooglemap.mapadsence.'.(int) $mapadsenceId;
		}

		$actions = array(
			'core.admin', 'core.manage', 'core.create', 'core.edit', 'core.edit.state', 'core.edit.own', 'core.delete'
		);

		foreach ($actions as $action) {
			$result->set($action,	$user->authorise($action, $assetName));
		}

		return $result;
	}
	
	
	
}
