<?php
/*------------------------------------------------------------------------
# com_zhgooglemap - Zh GoogleMap
# ------------------------------------------------------------------------
# author    Dmitry Zhuk
# copyright Copyright (C) 2011 zhuk.cc. All Rights Reserved.
# @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPLv2 or later
# Websites: http://zhuk.cc
# Technical Support Forum: http://forum.zhuk.cc/
-------------------------------------------------------------------------*/
// No direct access to this file
defined('_JEXEC') or die('Restricted access');

/**
 * ZhGoogleMap component helper.
 */
abstract class ZhGoogleMapHelper
{

	/**
	 * Get the actions
	 */
	public static function getMapActions($mapId = 0)
	{
		$user	= JFactory::getUser();
		$result	= new JObject;

		if (empty($mapId)) {
			$assetName = 'com_zhgooglemap';
		}
		else {
			$assetName = 'com_zhgooglemap';
			//$assetName = 'com_zhgooglemap.map.'.(int) $mapId;
		}

		$actions = array(
			'core.admin', 'core.manage', 'core.create', 'core.edit', 'core.edit.state', 'core.edit.own', 'core.delete'
		);

		foreach ($actions as $action) {
			$result->set($action,	$user->authorise($action, $assetName));
		}

		return $result;
	}

	public static function getMarkerActions($mapmarkerId = 0)
	{
		$user	= JFactory::getUser();
		$result	= new JObject;

		if (empty($mapmarkerId)) {
			$assetName = 'com_zhgooglemap';
		}
		else {
			$assetName = 'com_zhgooglemap';
			//$assetName = 'com_zhgooglemap.mapmarker.'.(int) $mapmarkerId;
		}

		$actions = array(
			'core.admin', 'core.manage', 'core.create', 'core.edit', 'core.edit.state', 'core.edit.own', 'core.delete'
		);

		foreach ($actions as $action) {
			$result->set($action,	$user->authorise($action, $assetName));
		}

		return $result;
	}

	public static function getMarkerGroupActions($mapmarkerGroupId = 0)
	{
		$user	= JFactory::getUser();
		$result	= new JObject;

		if (empty($mapmarkerGroupId)) {
			$assetName = 'com_zhgooglemap';
		}
		else {
			$assetName = 'com_zhgooglemap';
			//$assetName = 'com_zhgooglemap.mapmarkergroup.'.(int) $mapmarkerGroupId;
		}

		$actions = array(
			'core.admin', 'core.manage', 'core.create', 'core.edit', 'core.edit.state', 'core.edit.own', 'core.delete'
		);

		foreach ($actions as $action) {
			$result->set($action,	$user->authorise($action, $assetName));
		}

		return $result;
	}


	public static function getRouterActions($maprouterId = 0)
	{
		$user	= JFactory::getUser();
		$result	= new JObject;

		if (empty($maprouterId)) {
			$assetName = 'com_zhgooglemap';
		}
		else {
			$assetName = 'com_zhgooglemap';
			//$assetName = 'com_zhgooglemap.maprouter.'.(int) $maprouterId;
		}

		$actions = array(
			'core.admin', 'core.manage', 'core.create', 'core.edit', 'core.edit.state', 'core.edit.own', 'core.delete'
		);

		foreach ($actions as $action) {
			$result->set($action,	$user->authorise($action, $assetName));
		}

		return $result;
	}

	public static function getPathActions($mappathId = 0)
	{
		$user	= JFactory::getUser();
		$result	= new JObject;

		if (empty($mappathId)) {
			$assetName = 'com_zhgooglemap';
		}
		else {
			$assetName = 'com_zhgooglemap';
			//$assetName = 'com_zhgooglemap.mappath.'.(int) $mappathId;
		}

		$actions = array(
			'core.admin', 'core.manage', 'core.create', 'core.edit', 'core.edit.state', 'core.edit.own', 'core.delete'
		);

		foreach ($actions as $action) {
			$result->set($action,	$user->authorise($action, $assetName));
		}

		return $result;
	}

	public static function getTypeActions($maptypeId = 0)
	{
		$user	= JFactory::getUser();
		$result	= new JObject;

		if (empty($maptypeId)) {
			$assetName = 'com_zhgooglemap';
		}
		else {
			$assetName = 'com_zhgooglemap';
			//$assetName = 'com_zhgooglemap.maptype.'.(int) $maptypeId;
		}

		$actions = array(
			'core.admin', 'core.manage', 'core.create', 'core.edit', 'core.edit.state', 'core.edit.own', 'core.delete'
		);

		foreach ($actions as $action) {
			$result->set($action,	$user->authorise($action, $assetName));
		}

		return $result;
	}
	

	public static function getInfoBubbleActions($mapinfobubbleId = 0)
	{
		$user	= JFactory::getUser();
		$result	= new JObject;

		if (empty($mapinfobubbleId)) {
			$assetName = 'com_zhgooglemap';
		}
		else {
			$assetName = 'com_zhgooglemap';
			//$assetName = 'com_zhgooglemap.mapinfobubble.'.(int) $mapinfobubbleId;
		}

		$actions = array(
			'core.admin', 'core.manage', 'core.create', 'core.edit', 'core.edit.state', 'core.edit.own', 'core.delete'
		);

		foreach ($actions as $action) {
			$result->set($action,	$user->authorise($action, $assetName));
		}

		return $result;
	}
	

	
	public static function getStreetViewActions($mapstreetviewId = 0)
	{
		$user	= JFactory::getUser();
		$result	= new JObject;

		if (empty($mapstreetviewId)) {
			$assetName = 'com_zhgooglemap';
		}
		else {
			$assetName = 'com_zhgooglemap';
			//$assetName = 'com_zhgooglemap.mapstreetview.'.(int) $mapstreetviewId;
		}

		$actions = array(
			'core.admin', 'core.manage', 'core.create', 'core.edit', 'core.edit.state', 'core.edit.own', 'core.delete'
		);

		foreach ($actions as $action) {
			$result->set($action,	$user->authorise($action, $assetName));
		}

		return $result;
	}

	public static function getWeatherTypeActions($mapweathertypeId = 0)
	{
		$user	= JFactory::getUser();
		$result	= new JObject;

		if (empty($mapweathertypeId)) {
			$assetName = 'com_zhgooglemap';
		}
		else {
			$assetName = 'com_zhgooglemap';
			//$assetName = 'com_zhgooglemap.mapweathertype.'.(int) $mapweathertypeId;
		}

		$actions = array(
			'core.admin', 'core.manage', 'core.create', 'core.edit', 'core.edit.state', 'core.edit.own', 'core.delete'
		);

		foreach ($actions as $action) {
			$result->set($action,	$user->authorise($action, $assetName));
		}

		return $result;
	}

	public static function getWidgetTypeActions($mapwidgettypeId = 0)
	{
		$user	= JFactory::getUser();
		$result	= new JObject;

		if (empty($mapwidgettypeId)) {
			$assetName = 'com_zhgooglemap';
		}
		else {
			$assetName = 'com_zhgooglemap';
			//$assetName = 'com_zhgooglemap.mapwidgettype.'.(int) $mapwidgettypeId;
		}

		$actions = array(
			'core.admin', 'core.manage', 'core.create', 'core.edit', 'core.edit.state', 'core.edit.own', 'core.delete'
		);

		foreach ($actions as $action) {
			$result->set($action,	$user->authorise($action, $assetName));
		}

		return $result;
	}

	public static function getAdSenceActions($mapadsenceId = 0)
	{
		$user	= JFactory::getUser();
		$result	= new JObject;

		if (empty($mapadsenceId)) {
			$assetName = 'com_zhgooglemap';
		}
		else {
			$assetName = 'com_zhgooglemap';
			//$assetName = 'com_zhgooglemap.mapadsence.'.(int) $mapadsenceId;
		}

		$actions = array(
			'core.admin', 'core.manage', 'core.create', 'core.edit', 'core.edit.state', 'core.edit.own', 'core.delete'
		);

		foreach ($actions as $action) {
			$result->set($action,	$user->authorise($action, $assetName));
		}

		return $result;
	}
	
	
	
}
